#include <tamtypes.h>
#include <kernel.h>
#include <loadfile.h>
#include <stdio.h>
#include <sifrpc.h>
#include <graph_registers.h>
#include <libpad.h>
#include <debug.h>
// L[obt@i[p
static char padBuf[256] __attribute__((aligned(64)));

// KvW[̃[h
void loadModules(){
	if((SifLoadModule("rom0:XSIO2MAN", 0, NULL)) < 0){
		printf("Failed to load XSIO2MAN module\n");
		SleepThread();
	}
	if((SifLoadModule("rom0:XPADMAN", 0, NULL)) < 0){
		printf("Failed to load XPADMAN module\n");
		SleepThread();
	}
}
// ҂
void wait_vsync(){
	GS_REG_CSR |= GS_SET_CSR(0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0);
	while (!(GS_REG_CSR & (GS_SET_CSR(0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0)))) { }
	GS_REG_CSR &= ~GS_SET_CSR(0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0);
}
// C[`
int main(){
	struct padButtonStatus buttons;
	u32 paddata;
	int x=0,y=0;
	init_scr(); SifInitRpc(0); loadModules(); padInit(0); padPortOpen(0,0,padBuf);
	while(1){
		s32 ret = padRead(0, 0, &buttons);
		paddata = buttons.btns^0xFFFF;
		if(ret!=0){
			if(paddata & PAD_LEFT)  x-=3;
			if(paddata & PAD_RIGHT) x+=3;
			if(paddata & PAD_UP)    y-=3;
			if(paddata & PAD_DOWN)  y+=3;
		}
		_putchar(x,y,0xFFFFFF,'*');
		wait_vsync();
	}
	return 0;
}
